; Ben / Hulud for St(Art)'0 fast code compo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

[org 100h]
[segment .text]

%define	num_pts			100
%define ptsdup			0x8000-4*num_pts
%define buffer_start	ptsdup

; ax=0 at start of a .com

Load_File:
	mov		dx, file
	mov		ah, 0x3d
	int		21h

	; xchg = 1 byte
	; assume al == 0
	; assume ch == 0
	; dx = file : override the 'file' string buffer
	xchg	bx, ax
	mov		ah, 0x3f
	mov		cl, 200
	int		21h

	; gfx on
	mov		al,13h
	int		10h

	; dup coordinates in dword
	mov		si, dx
	mov		di, ptsdup
	push	di

	; unpack position in word for use with fild

	; brute force search
	; for each vertex
Loop_Dup:
	lodsb
	stosw
	loop	Loop_Dup

	push 	word 0xa000
	pop 	es

	pop		si
	push	si

	; for each edge possible for this vertex
Loop_0:

	pop		bx	; get buffer_start on stack -> ind_j
	push	bx

	; check all points are on the same side of the edge with a cross product
Loop_1:


	pop		di	; get buffer_start on stack -> ind_k
	push	di

	; (assume (ax&0x80) == 0) : clear dx with 1 byte
	cwd

Loop_2:

	; cross product
	call	SemiProd
	call	SemiProd
	fcompp

	; 'nowait' version : save 1 byte
	fnstsw	ax
	sahf

	; assume ch = 0
	mov		cl, 4

	jb		NextEdge	; if negative => failed for this edge

	je		NextVert	; if equal => can't say anything
	inc		dx			; positive => potential hull vertex

NextVert:

	; red color in the default palette
	mov		al, 4
	add		di, cx
	jns		Loop_2


	dec		dl		; all edges tested, if potential => vert belongs to hull
	jge		PlotPix

NextEdge:

	add		bx, cx
	jns		Loop_1

	; white color in the default palette
	mov		al, 15

PlotPix:

	mov		di, [si+2]
	imul	di, 320
	add		di, [si]
	stosb

	add		si, cx
	jns		Loop_0


	pop		si

Wait_Esc:

	; assume dx = 0, mov dx into ax with 1 byte
	xchg	ax,dx
	int		16h

Exit:
	; assume cx = 4, mov dx into ax with 1 byte
	xchg	ax,cx
	dec		ax
	int		10h

SemiProd:
	fild	word [di]
	fisub	word [si]
	fild	word [bx+2]
	fisub	word [si+2]
	fmulp   st1
	xchg	bx, di
	ret

file: 		db	'a', 0
